<?php
//Security-Check
if (eregi("admin.class.php",$_SERVER['PHP_SELF'])) 
{
    Header("Location: index.php");
    die();
}

// Checks empty entries
function checkEntryData($var) 
{
    return (trim($var)!=""); 
}

/**
* Class voting manager
*
* Class for the voting system
*
* @copyright   ASTALAVISTA SECURE CMS - 2004 Astalavista Group GmbH
* @author      Leandro Nery <nery@astalavista.net>              
* @module      Voting
* @modulegroup shop                                                                                     
* @version	   $Id: admin.inc.php,v 1.00 $
*/

class votingmanager
{
	var $_objTpl;
    var $statusMessage = "";
    
    /**
    * Constructor
    *
    * @version 1.0    initial version
    * @param  string  
    * @access public
    */
    
    function votingmanager ()
    {
    	global $_ARRAYLANG, $objTemplate;
    	
    	
    	$this->_objTpl = &new HTML_Template_Sigma(ASCMS_MODULE_PATH.'/voting/template');
    	$this->_objTpl->setErrorHandling(PEAR_ERROR_DIE);
    	
    	$objTemplate->setVariable(array(
    	    'CONTENT_TITLE'      => $_ARRAYLANG['TXT_VOTING_MANAGER'],
    	    'CONTENT_NAVIGATION' => "<a href='?cmd=voting'>[".$_ARRAYLANG['TXT_VOTING_RESULTS']."]</a> 
    	                           <a href='?cmd=voting&act=add'>[".$_ARRAYLANG['TXT_VOTING_ADD']."]</a>
    	                           <a href='?cmd=voting&act=disablestatus'>[".$_ARRAYLANG['TXT_VOTING_DISABLE']."]</a>"    
    	   ));
    }

      
    function getVotingPage()
    {
    	global $_ARRAYLANG, $objTemplate;
   	    	
        switch($_GET['act'])
		{
			case "add":
                $action = $this->votingAdd($pageContent);
			break;

			case "edit":
                $action = $this->votingEdit($pageContent);
			break;

			    
		    case "addsubmit":
                $action = $this->votingAddSubmit();
                if ($action)
                {
                   $this->statusMessage=$_ARRAYLANG['TXT_DATA_RECORD_STORED_SUCCESSFUL'];
                   $action = $this->showCurrent($pageContent);
                }
                else
                {
                   $this->statusMessage=$_ARRAYLANG['TXT_SUBMIT_ERROR'];
                   $action = $this->votingAdd($pageContent);
                }
			break;
			    
		    case "editsubmit":
                $action = $this->votingEditSubmit();
                if ($action)
                   $this->statusMessage=$_ARRAYLANG['TXT_DATA_RECORD_STORED_SUCCESSFUL'];
                else
                   $this->statusMessage=$_ARRAYLANG['TXT_SUBMIT_ERROR'];

                $action = $this->showCurrent($pageContent);
		    break;
			    
			case "changestatus":
                $action = $this->changeStatus();
                $action = $this->showCurrent($pageContent);
			break;
			    			    
		 	case "disablestatus":
                $action = $this->DisableStatus();
                $action = $this->showCurrent($pageContent);
			break;
			    
		    case "delete":
                $action = $this->votingDelete();
                $action = $this->showCurrent($pageContent);
			break;
			    			    
			case "code":
				$action = $this->votingCode($pageContent);
			break;
			
			default:
                $action = $this->showCurrent($pageContent);
		}
		
		$objTemplate->setVariable(array(
			'CONTENT_STATUS_MESSAGE'	=> ltrim($this->statusMessage),
			'ADMIN_CONTENT'				=> $this->_objTpl->get()
		));
    }
    
    function showCurrent()
    {
    	global $db, $_ARRAYLANG;

    	$this->_objTpl->loadTemplateFile('voting_results.html');
    	
    	$query= "SELECT id FROM ".DBPREFIX."voting_system";
    	$db->query($query);
        $totalrows= $db->num_rows();
		    	
    	if ($_GET['votingid'] && $_GET['act']!="delete")
    	{
    	    $query= "SELECT id, UNIX_TIMESTAMP(date) as datesec, question, votes FROM ".DBPREFIX."voting_system where id=".intval($_GET['votingid'])." order by id desc";
    	}
    	else  	
    	{
    		$query= "SELECT id, UNIX_TIMESTAMP(date) as datesec, question, votes  FROM ".DBPREFIX."voting_system where status=1";
    	}

		$db->query($query);
		if ($db->num_rows()==0 && $totalrows==0)
		{
		   header("Location: ?cmd=voting&act=add");
		}
		else 
		{   
			if ($db->num_rows()==0)
			{
				$query= "SELECT id, UNIX_TIMESTAMP(date) as datesec, question, votes  FROM ".DBPREFIX."voting_system";
				$db->query($query);
			}
			if ($db->next_record())
			{
				$votingId=$db->f('id');
				$votingTitle=stripslashes($db->f('question'));
				$votingVotes=$db->f('votes');
				$votingDate=$db->f('datesec');
			}
			else 
	    	{
	    		$this->errorHandling();
	    	    return false;	
	    	}
			
			$images = 1;		
			$query="SELECT id, question, votes FROM ".DBPREFIX."voting_results WHERE voting_system_id='$votingId' ORDER BY id";
			$db->query($query);
			while ($db->next_record())
			{
				$votes=intval($db->f('votes'));
				$percentage = 0;
				$imagewidth = 1; //Mozilla Bug if image width=0					
				if($votes>0)
				{
				    $percentage = (round(($votes/$votingVotes)*10000))/100;
				    $imagewidth = round($percentage,0);
				}
				$votingResultText .= stripslashes($db->f('question'))."<br>\n";
				$votingResultText .= "<img src='images/icons/$images.gif' width='$imagewidth%' height=10>";
				$votingResultText .= "&nbsp;<font size=1>$votes ".$_ARRAYLANG['TXT_VOTES']." / $percentage %</font><br>\n";				
			}
			
			$this->_objTpl->setVariable(array(
			    'VOTING_TITLE'               => $votingTitle,
			    'VOTING_DATE'                => showFormattedDate($votingDate),
				'VOTING_RESULTS_TEXT'	       => $votingResultText,
				'VOTING_RESULTS_TOTAL_VOTES' => $votingVotes,	
				'VOTING_TOTAL_TEXT'          => $_ARRAYLANG['TXT_VOTING_TOTAL'],
				'TXT_DATE'                   => $_ARRAYLANG['TXT_DATE'],
				'TXT_TITLE'                  => $_ARRAYLANG['TXT_TITLE'],
				'TXT_VOTES'                  => $_ARRAYLANG['TXT_VOTES'],
				'TXT_ACTION'	               => $_ARRAYLANG['TXT_ACTION'],		
				'TXT_ACTIVATION'             => $_ARRAYLANG['TXT_ACTIVATION'],
				'TXT_CREATE_HTML'		       => $_ARRAYLANG['TXT_CREATE_HTML'],
				'TXT_CONFIRM_DELETE_DATA'    => $_ARRAYLANG['TXT_CONFIRM_DELETE_DATA'],
				'TXT_ACTION_IS_IRREVERSIBLE' => $_ARRAYLANG['TXT_ACTION_IS_IRREVERSIBLE']
			));
			
			$this->_objTpl->setGlobalVariable('TXT_HTML_CODE', $_ARRAYLANG['TXT_HTML_CODE']);
				
			// show other Voting entries 	
			$query="SELECT id,status, UNIX_TIMESTAMP(date) as datesec, title, votes FROM ".DBPREFIX."voting_system order by id desc";
			$db->query($query);
			while($db->next_record())
			{
			    $votingid=$db->f('id');
				$votingTitle=stripslashes($db->f('title'));
				$votingVotes=$db->f('votes');
				$votingDate=$db->f('datesec');	
				$votingStatus=$db->f('status');		
									
				if ($votingStatus==0)
				{
					 $radio=" onclick=\"Javascript: window.location.replace('?cmd=voting&act=changestatus&votingid=$votingid');\">";
				}
				else
				{
					 $radio=" checked>";
				}
				if (($i % 2) == 0) 
				{
					$class="row1";
				}
				else 
				{
					$class="row2";
				}						
				
				$this->_objTpl->setVariable(array(
					'VOTING_OLDER_TEXT'	   => "<a href='?cmd=voting&votingid=$votingid'>".$votingTitle."</a>",
					'VOTING_OLDER_DATE'      => showFormattedDate($votingDate),
					'VOTING_OLDER_VOTES'     => $votingVotes,
					'VOTING_ID'              => $votingid,
					'VOTING_LIST_CLASS'      => $class,
					'VOTING_RADIO'           => "<input type='radio' name='voting_selected' value='radiobutton'".$radio						
				));
				$this->_objTpl->parse("votingRow");
				$i++;
			}
		}						
	}
		
    /**
     * @return unknown
     * @desc Beschreibung eingeben...
     */
	
	
    function votingAddSubmit()
    {
    	global $db;

    	if (empty($_POST['votingquestion']) || empty($_POST['votingname'])) return false;
    	$options= explode ("\n", $_POST['votingoptions']);
    	    	
    	if (count(array_filter($options,'checkEntryData'))<2)
    	{
        	return false;    
    	}
    	
    	$query="UPDATE ".DBPREFIX."voting_system set status=0,date=date";
		$db->query($query);	 
       	$query="INSERT INTO ".DBPREFIX."voting_system (title,question,status,votes)  values ('".htmlspecialchars(addslashes($_POST['votingname']))."','".htmlspecialchars(addslashes($_POST['votingquestion']))."','1','0')";
		$db->query($query);	
    	$db->query("SELECT MAX(id) as max_id FROM ".DBPREFIX."voting_system");
        if ($db->next_record())
        {
        	$latestid=$db->f("max_id");
        }
        else
        {
    		$this->errorHandling();
    	    return false;    	       	    
    	}                    	
    	
    	for ($i=0;$i<count($options);$i++)
    	{
           $query="INSERT INTO ".DBPREFIX."voting_results (voting_system_id,question,votes)  values ($latestid,'".htmlspecialchars(addslashes(trim($options[$i])))."',0)";
           if (trim($options[$i])!="")
           {
           		$db->query($query);	
           }
    	}    	
    	return true;
	}	
	
	function votingEditSubmit()
    {
    	global $db;
		$deleted_votes=0;
		
    	if (empty($_POST['votingquestion']) || empty($_POST['votingname']))
    	{
    		return false;
    	}
    			
    	$options= explode ("\n", $_POST['votingoptions']);    	
    	$optionsid= explode (";", $_POST['votingresults']);    	    
    	$looptimes=max(count($options),count($optionsid));	    	
    	
    	if (count(array_filter($options,"checkEntryData"))<2)
    	{
    		
        	return false;    
    	}	       	
   	
    	for ($i=0;$i<$looptimes;$i++)
    	{
    		if (trim($options[$i])!="")
            {
            	if ($optionsid[$i]!="")
            	{            		
            		$query="UPDATE ".DBPREFIX."voting_results set question='".htmlspecialchars(addslashes(trim($options[$i])))."' WHERE id='".intval($optionsid[$i])."'";
		    		$db->query($query);	 
            	}
            	else 
            	{                       
 					$query="INSERT INTO ".DBPREFIX."voting_results (voting_system_id,question,votes) values ('".intval($_POST['votingid'])."','".htmlspecialchars(addslashes(trim($options[$i])))."',0)";            	
            		$db->query($query);
            	}
            }
            elseif ($optionsid[$i]!="")
            {
            	$query="SELECT votes FROM ".DBPREFIX."voting_results WHERE id='".intval($optionsid[$i])."'";      	
            	$db->query($query); 
            	if ($db->next_record())
            	{
            		$deleted_votes=$db->f("votes");
            	}            	
            	
 				$query="DELETE FROM ".DBPREFIX."voting_results WHERE id='".intval($optionsid[$i])."'";
            	$db->query($query);                       		
            }
    	}  
    	 
    	$query="UPDATE ".DBPREFIX."voting_system set date=date, title='".htmlspecialchars(addslashes($_POST['votingname']))."',question='".htmlspecialchars(addslashes($_POST['votingquestion']))."',votes=votes-".$deleted_votes." WHERE id='".intval($_POST['votingid'])."'";
		if ($db->query($query))		
		{
    		return true;            
		}
		else 
		{
			return false;
		}
	}
	
	
	
	
	
	function votingDelete()
    {
    	global $db;
    	
    	// Case when deleting the status active, it has to set another
		$query="SELECT id FROM ".DBPREFIX."voting_system WHERE status=1";
		$db->query($query);	 
		if($db->next_record() && $_GET['votingid']==$db->f("id"))
		{		
			$query="SELECT  MAX(id) as maxid FROM ".DBPREFIX."voting_system WHERE status=0";
			$db->query($query);	 
			if($db->next_record())				
			{
			   $maxid=$db->f("maxid");
			   if (!is_null($maxid))
			   {
			   		$query="UPDATE ".DBPREFIX."voting_system set status=1,date=date WHERE id=$maxid";			   		
		       		$db->query($query);	
			   }
			}
			
		}
      	$query="DELETE FROM ".DBPREFIX."voting_system WHERE id=".intval($_GET['votingid'])." ";
		$db->query($query);	
  		$query="DELETE FROM ".DBPREFIX."voting_results WHERE voting_system_id=".intval($_GET['votingid'])." ";
		$db->query($query);
	}
	
	
	function changeStatus()
    {
    	global $db;

    	$query="UPDATE ".DBPREFIX."voting_system set status=0, date=date";
		$db->query($query);	
		$query="UPDATE ".DBPREFIX."voting_system set status=1,date=date where id=".intval($_GET['votingid'])." ";
		$db->query($query);	    							
	}
	
	
	function DisableStatus()
    {
    	global $db;

    	$query="UPDATE ".DBPREFIX."voting_system set status=0, date=date";
		$db->query($query);	
	}
	

    function votingAdd()
    {
    	global $_ARRAYLANG;

    	$this->_objTpl->loadTemplateFile('voting_add.html');
   	
		$this->_objTpl->setVariable(array(
		    'TXT_VOTING_ADD'         => $_ARRAYLANG['TXT_VOTING_ADD'],
			'TXT_NAME'	           => $_ARRAYLANG['TXT_NAME'],
			'TXT_VOTING_QUESTION'    => $_ARRAYLANG['TXT_VOTING_QUESTION'],	
			'TXT_VOTING_ADD_OPTIONS' => $_ARRAYLANG['TXT_VOTING_ADD_OPTIONS'],
			'TXT_STORE'              => $_ARRAYLANG['TXT_STORE'],
			'TXT_RESET'              => $_ARRAYLANG['TXT_RESET']		
		));
	}


	function votingEdit()
    {
    	global $db, $_ARRAYLANG;

    	$this->_objTpl->loadTemplateFile('voting_edit.html');
    	$query="SELECT * FROM ".DBPREFIX."voting_system where id=".intval($_GET['votingid'])." ";
		$db->query($query);	   	
		if($db->next_record())				
		{	
			$votingname=stripslashes($db->f("title"));
			$votingquestion=stripslashes($db->f("question"));
			$votingid=$db->f("id");			
		}	
		
		$query="SELECT question,id FROM ".DBPREFIX."voting_results WHERE voting_system_id='$votingid' ORDER BY id";
		$db->query($query);
		$i=0;
		while ($db->next_record())
		{
			$votingoptions .= stripslashes($db->f('question'))."\n";			
			$voltingresults[$i]=$db->f('id');
			$i++;
		}
		
		$this->_objTpl->setVariable(array(
		    'TXT_VOTING_EDIT'        => $_ARRAYLANG['TXT_VOTING_EDIT'],
			'TXT_NAME'	           => $_ARRAYLANG['TXT_NAME'],
			'TXT_VOTING_QUESTION'    => $_ARRAYLANG['TXT_VOTING_QUESTION'],	
			'TXT_VOTING_ADD_OPTIONS' => $_ARRAYLANG['TXT_VOTING_ADD_OPTIONS'],
			'TXT_STORE'              => $_ARRAYLANG['TXT_STORE'],
			'TXT_RESET'              => $_ARRAYLANG['TXT_RESET'],
			'EDIT_NAME'			   => $votingname,
			'EDIT_QUESTION'		   => $votingquestion,
			'EDIT_OPTIONS' 		   => $votingoptions,
			'VOTING_ID'			   => $votingid,
			'VOTING_RESULTS'         => implode($voltingresults,";")
		));
	}


	function votingCode()
    {
    	global $db, $_ARRAYLANG;

    	$this->_objTpl->loadTemplateFile('voting_code.html');
    	
    	$query= "SELECT id, status, UNIX_TIMESTAMP(date) as datesec, question, votes FROM ".DBPREFIX."voting_system where id=".intval($_GET['votingid']);
		$db->query($query);	   	
		if($db->next_record())				
		{	    	
			$votingId=$db->f('id');
			$votingTitle=stripslashes($db->f('question'));
			$votingVotes=$db->f('votes');
			$votingDate=$db->f('datesec');
			$votingStatus=$db->f('status');
		}
		else 
	    {
	    	errorHandling();
	        return false;	
	    }
	    
		$query="SELECT id, question, votes FROM ".DBPREFIX."voting_results WHERE voting_system_id='$votingId' ORDER BY id";
		$db->query($query);
			
		while ($db->next_record())
		{
			$votingResultText .="<input type='radio' name='votingoption' value='".$db->f('id')."'> ";	
		    $votingResultText .= $db->f('question')."<br>\n";			    							
		}
				    	
		$submitbutton="<input class=input type='submit' value='".$_ARRAYLANG['TXT_SUBMIT']."' name='Submit'>";		  		
		
		$this->_objTpl->setVariable(array(
		    'VOTING_TITLE'             => $votingTitle." - ".showFormattedDate($votingDate),
		    'VOTING_CODE'              => $_ARRAYLANG['TXT_VOTING_CODE'],
		    'VOTING_RESULTS_TEXT'      => $votingResultText,
		    'TXT_SUBMIT'               => $submitbutton,
		    'TXT_SELECT_ALL'           => $_ARRAYLANG['TXT_SELECT_ALL']
					
		));
	}

	
    function errorHandling()
    {
    	global $_ARRAYLANG;
        $this->statusMessage.= " ".$_ARRAYLANG['TXT_DATABASE_QUERY_ERROR']." ";
    }
    
}